//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class bestanswer_hook_badfTopic extends _HOOK_CLASS_
{
	/**
	 * Set Best Answer
	 *
	 * @return	void
	 */
	public function bestAnswerPlugin()
	{
		try
		{
			try
			{
				try
				{
					try
					{
						\IPS\Session::i()->csrfCheck();
				
						try
						{
							$topic = \IPS\forums\Topic::loadAndCheckPerms( \IPS\Request::i()->id );
							if ( !$topic->canSetBestAnswerPlugin() )
							{
								throw new \OutOfRangeException;
							}
							
							$post = \IPS\forums\Topic\Post::loadAndCheckPerms( \IPS\Request::i()->answer );
							if ( $post->item() != $topic )
							{
								throw new \OutOfRangeException;
							}
						}
						catch ( \OutOfRangeException $e )
						{
							\IPS\Output::i()->error( 'node_error', 'BEST ANSWER/1', 404, '' );
						}
				
						if ( $topic->topic_answered_pid )
						{
							try
							{
								$oldBestAnswer = \IPS\forums\Topic\Post::load( $topic->topic_answered_pid );
								$oldBestAnswer->post_bwoptions['best_answer'] = FALSE;
								$oldBestAnswer->save();
							}
							catch ( \Exception $e ) {}
						}
				
						$post->post_bwoptions['best_answer'] = TRUE;
						$post->save();
				
						$topic->topic_answered_pid = $post->pid;
				
						if( \IPS\Settings::i()->resolvedForums_lockTopics )
						{
							$topic->state = 'closed';
						}
				
						/* Save it */
						$topic->save();
				
						/* Log */
						\IPS\Session::i()->modLog( 'modlog__best_answer_set', array( $post->pid => FALSE ), $topic );
				
						/* Notification */
						if( $post->author()->member_id != \IPS\Member::loggedIn()->member_id )
						{
							$notification = new \IPS\Notification( \IPS\Application::load( 'bestanswer' ), 'best_answer', $topic, array( $topic ), array( \IPS\Member::loggedIn()->member_id ) );
							$notification->recipients->attach( $post->author() );
							$notification->send();
						}
				
						/* Boink */
						\IPS\Output::i()->redirect( $topic->url()->setQueryString( array( 'do' => 'findComment', 'comment' => $topic->topic_answered_pid ) ) );
					}
					catch ( \RuntimeException $e )
					{
						if ( method_exists( get_parent_class(), __FUNCTION__ ) )
						{
							return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
						}
						else
						{
							throw $e;
						}
					}
				}
				catch ( \RuntimeException $e )
				{
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	/**
	 * Unset Best Answer
	 *
	 * @return	void
	 */
	public function unsetBestAnswerPlugin()
	{
		try
		{
			try
			{
				try
				{
					try
					{
						\IPS\Session::i()->csrfCheck();
				
						try
						{
							$topic = \IPS\forums\Topic::loadAndCheckPerms( \IPS\Request::i()->id );
				
							if ( !$topic->canSetBestAnswerPlugin() )
							{
								throw new \OutOfRangeException;
							}
						}
						catch ( \OutOfRangeException $e )
						{
							\IPS\Output::i()->error( 'node_error', 'BEST ANSWER/2', 404, '' );
						}
				
						if ( $topic->topic_answered_pid )
						{
							try
							{
								$post = \IPS\forums\Topic\Post::load( $topic->topic_answered_pid );
								$post->post_bwoptions['best_answer'] = FALSE;
								$post->save();
								
								\IPS\Session::i()->modLog( 'modlog__best_answer_unset', array( $topic->topic_answered_pid => FALSE ), $topic );
							}
							catch ( \Exception $e ) {}
						}
				
						$topic->topic_answered_pid = FALSE;
				
						if( \IPS\Settings::i()->resolvedForums_unlockTopics )
						{
							$topic->state = 'open';
						}
				
						/* Save it */
						$topic->save();
				
						/* Remove previous SET AS BEST ANSWER notification for this topic */
						\IPS\Db::i()->delete( 'core_notifications', array( 'notification_key=? AND item_id=?', 'best_answer', $topic->tid ) );
				
						/* Boink */
						\IPS\Output::i()->redirect( $topic->url(), 'resolvedForums_best_answer_unset' );
					}
					catch ( \RuntimeException $e )
					{
						if ( method_exists( get_parent_class(), __FUNCTION__ ) )
						{
							return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
						}
						else
						{
							throw $e;
						}
					}
				}
				catch ( \RuntimeException $e )
				{
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}